   '***********************************************************************'
   ' Bezici had - 2010                         '
   '                                                                       '
   ' v 1.0 (z 25.12.2010)                                                 '
   '                                                                       '
   ' Autor : Pavel Jank                                                   '
   ' www.paja-trb.cz                                                 
   ' paja@paja-trb.cz                                                   
   '                                                                       '
   '***********************************************************************'

' DIP1 nastaviteln poten prodleva po krocch 150ms (0-7x)
' DIP2 nastaviteln rychlost blikn efekt na max 245ms (7*30)
' DIP3 nastaven efektu blikn LEDek
' DIP4-6 po aktivovn jednoho z DIP 1-3 se tmito nastavuje binrn hodnota 0-7

'$sim                                                        '!!!Odstranit pi programovn - zrychlen simulace

$regfile = "m8def.dat"                                      'Soubor s deklaracemi
$crystal = 8000000                                          'Kmitoet osciltoru v Hz
$hwstack = 32
$swstack = 8
$framesize = 16

Dim A As Byte
Dim Opakovani As Byte
Dim Hodnota As Byte
Dim Prodlevasave As Eram Byte At 1                          'hodnoty v EEPROM
Dim Rychlostsave As Eram Byte At 2
Dim Funkcesave As Eram Byte At 3
Dim Pocetstrobo As Eram Byte At 4
Dim Pocetsipek As Eram Byte At 5

Dim Prodleva As Byte
Dim Rychlost As Byte

Dim Dipy123 As Byte
Dim Ddip4 As Byte
Dim Ddip6 As Byte

'pojmenovani jednotlivych pinu port
Led1 Alias Portc.0                                          'pojmenuje portc.0 jako Led1
Led2 Alias Portc.1
Led3 Alias Portc.2
Led4 Alias Portc.3
Led5 Alias Portc.4
Led6 Alias Portc.5
Led7 Alias Portd.0
Led8 Alias Portd.1
Led9 Alias Portd.2
Led10 Alias Portd.3

Piezo Alias Portd.4
Piezo = 0

'Dip1 Alias Pinb.2
'Dip2 Alias Pinb.1
'Dip3 Alias Pinb.0
'Dip4 Alias Pind.7
'Dip5 Alias Pind.6
'Dip6 Alias Pind.5

'nastaveni jednotlivych portu C jako vystupni
Config Portc = Output                                       'cely port C vystupni (LEDky1-6)
Config Portb = &B_1111_1000                                 'DIP 1-3 vstupn
Config Portd = &B_0001_1111                                 'DIP 4-6 vstupni, LEDky7-10 vystupni
Portb = &B_1111_1111
Portc = &B_0000_0000
Portd = &B_1110_0000

'nastaveni preruseni kazdych 0,16s, kdy skoci na na cteni dipu ...
Config Timer1 = Timer , Prescale = 256                      '1krok tae = 1 / 8 (MHz) * 256 (peddli) = 32 mikrosec
On Timer1 Cti_dip                                           'obsluha peruen od Timeru1
Timer1 = 60000                                              'Poten hodnota registru TCNT1 (t od 0 do max. 65536 "16bit" -> 32mikrosec * 5536 = 0,17s)
Enable Timer1                                               'povol timer1
Enable Interrupts                                           'povol vechna peruen


'''''''''''''''''''''''''''' HLAVNI PROGRAM ''''''''''''''''''''''''''''''''''

'u nove naprogramovaneho procesoru je nastaveno 255 hodnot - toto je jejich omezeni na 7
If Prodlevasave > 7 Then Prodlevasave = 7
If Rychlostsave > 7 Then Rychlostsave = 7
If Funkcesave > 7 Then Funkcesave = 7
If Pocetstrobo > 14 Then Pocetstrobo = 14
If Pocetsipek > 7 Then Pocetsipek = 7

'prvotn naten DIP a vbr funkce
Gosub Cti_dip                                               'vyvola podprogram steni z DIPp

Start Timer1
Waitms 10
Gosub Vyber_funkce

End


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''


'===============================================================================

' Vyber z nastavenych (a ulozenych) funkci
Vyber_funkce:

Portc = &B_0000_0000
Led9 = 0
Led10 = 0

Select Case Funkcesave
  Case 0 : Gosub Strobo_policie
  Case 1 : Gosub Akce_dvere
  Case 2 : Gosub Rotacep                                    'rotace do Prava
  Case 3 : Gosub Rotacel                                    'rotace do Leva
  Case 4 : Gosub Stroboskop
  Case 5 : Gosub Bezici_tma                                 'tma
  Case 6 : Gosub Knight_rider
  Case 7 : Gosub Knight_rider_new
End Select

Return

'===============================================================================

'program vyvolan peruenm (nati DIPy a je-li teba vyber novou funkci)
' Cteni z DIP prepnacu      (osetreno, aby pro zapnuti "nesmyslene" kombinace zapiskalo piezo a nic se nenacetlo)
Cti_dip:

Stop Timer1                                                 'zastav asova (aby nekecal do natn DIP)
Timer1 = 60000                                              'znovunastav casovac

Dipy123 = Pinb                                              'nacti hodnotu na portu B
Toggle Dipy123                                              'ivertuj nactenou hodnotu - log. 0 spina !
Dipy123 = Dipy123 And &B0000_0111                           'vynulovn ostatnch nepotebch bit (pro jistotu)
              'zustane  0000_0xxx
Select Case Dipy123                                         'vyber z nactene hodnoty
   Case &B0000_0000:
      Goto Necti                                            'nic se nenacetlo
   Case &B0000_0100:                                        'DIP1 PinB.2
      Gosub Ctihodnotu
      Prodlevasave = Hodnota                                'nactena hodnota se ulozi do prodlevasave (v pameti EEPROM)
   Case &B0000_0010:                                        'DIP2 PinB.1
      Gosub Ctihodnotu
      If Hodnota = 0 Then
      Rychlostsave = 1
      Else
      Rychlostsave = Hodnota
      End If
   Case &B0000_0001:                                        'DIP3 PinB.0
      Gosub Ctihodnotu
      Funkcesave = Hodnota                                  'nactenou hodnotu uloz do pameti
   Case &B0000_0101:                                        'DIP3 a DIP1
      Gosub Ctihodnotu
      Hodnota = Hodnota * 2
      Pocetstrobo = Hodnota
   Case &B0000_0111:                                        'DIP3 a DIP2 a DIP1
      Gosub Ctihodnotu
      Pocetsipek = Hodnota                                  'nactenou hodnotu uloz do pameti
   Case Else:                                               'jeli zapnuto vic prepinaci tak chyba - zapiska
      Set Piezo
      Waitms 200
      Reset Piezo
End Select

Necti:
Waitms 10                                                   'ochrana porti zakmitum

Rychlost = Rychlostsave * 30                                'znovunastaveni rychlosti (v pripade noveho nacteni z DIPu)
Start Timer1                                                'spust casovac

Return

'===============================================================================

' podprogram pro cteni hodnoty z DIP prepinacu 4-6
Ctihodnotu:

Hodnota = Pind                                              'nacti hodnotu na portu D
Toggle Hodnota                                              'ivertuj nactenou hodnotu - log. 0 spina !

Shift Hodnota , Right , 5                                   'posun nactenou hodnotu ze 7,6,5 pozice na 2,1,0 pozici (nove bude rozsah 8hodnot)
Hodnota = Hodnota And &B0000_0111                           'vynulovn ostatnch nepotebch bit (pro jistotu)
              'zustane  0000_0xxx

' prohodi 0 a 2 bit vzajemne - kvuli prehozenemu pripojeni DIP prepinacu na porty porcesoru
Ddip4 = Hodnota
Shift Ddip4 , Right , 2
Ddip6 = Hodnota
Shift Ddip6 , Left , 2

Hodnota = Hodnota And &B0000_0010                           'vyma 0 a 2 bit
Hodnota = Hodnota Or Ddip4                                  'pricti 0 bit
Hodnota = Hodnota Or Ddip6                                  'pricti 2 bit
Hodnota = Hodnota And &B0000_0111                           'vynulovn ostatnch nepotebch bit (pro jistotu)

Waitms 50                                                   'ochrana proti zakmitum

Return

'===============================================================================
'===============================================================================

'blika vzdy 3x 5LED na jedny strane a pak 3x 5LED na druhy strane - porad dokola
Strobo_policie:

Portc = &B0000_0000
Portd = &B1110_0000

Do

Waitms Rychlost

Opakovani = 3
Do
Portc = &B0001_1111
Waitms Rychlost
Portc = &B0000_0000
Waitms Rychlost
Decr Opakovani
Loop Until Opakovani = 0

Waitms Rychlost

   If Funkcesave <> 0 Then
   Goto Vyber_funkce
   End If

Opakovani = 3
Do
Led6 = 1
Portd = &B1110_1111
Waitms Rychlost
Portd = &B1110_0000
Led6 = 0
Waitms Rychlost
Decr Opakovani
Loop Until Opakovani = 0

   If Funkcesave <> 0 Then
   Goto Vyber_funkce
   End If

Loop

Return

'===============================================================================

Akce_dvere:                                                 'pocka nastaveny cas (pro odjisteni zamku) - celkovy cas = 150ms * (0 az 7)

Portc = &B0000_0000
Portd = &B1110_0000

Led9 = 1                                                    'zapni led9 - "stuj"

Prodleva = Prodlevasave                                     'nacti nastavenou hodnotu z pameti (0-7)
If Prodleva = 0 Then
Goto Preskocprodlevu
End If

Do
Waitms 150
Decr Prodleva
Loop Until Prodleva = 0
Prodleva = Prodlevasave

Led9 = 0                                                    'vypni led9 - "stuj"
Led10 = 1                                                   'zapni led10 - "volno"

   Stop Timer1                                              'zastav asova - prerusoval piskani
   Set Piezo                                                'parkrat si zapiskej
   Waitms 100
   Reset Piezo
   Waitms 80
   Set Piezo
   Waitms 150
   Reset Piezo
   Start Timer1

Preskocprodlevu:

   If Funkcesave <> 1 Then
   Goto Vyber_funkce
   End If

Waitms 50

Do

'stroboskop - vsech 10 LED naraz
Opakovani = Pocetstrobo
If Opakovani = 0 Then
Goto Preskocstrobo:
End If

Do
Portc = &B0011_1111
Led7 = 1
Led8 = 1
Waitms Rychlost
Portc = &B0000_0000
Led7 = 0
Led8 = 0
Waitms Rychlost

   If Funkcesave <> 1 Then
   Goto Vyber_funkce
   End If

Decr Opakovani
Loop Until Opakovani = 0

Preskocstrobo:

Waitms 100

' "sipka" doleva
Opakovani = Pocetsipek
If Opakovani = 0 Then
Goto Preskocsipku
End If

Do
Portc = &B0000_0001
Waitms Rychlost
Portc = &B0000_0010
Waitms Rychlost
Portc = &B0000_0100
Waitms Rychlost
Portc = &B0000_1000
Waitms Rychlost
Portc = &B0001_0000
Waitms Rychlost
Portc = &B0010_0000
Waitms Rychlost
Portc = &B0000_0000
Led7 = 1
Waitms Rychlost
Led7 = 0
Led8 = 1
Waitms Rychlost
Led8 = 0

   If Funkcesave <> 1 Then
   Goto Vyber_funkce
   End If

   Decr Opakovani
Loop Until Opakovani = 0

Preskocsipku:

Loop Until Funkcesave <> 1
   Goto Vyber_funkce

Return

'===============================================================================

Rotacep:

Do
Portc = &B_00000000
Portd = &B_11101000
Waitms Rychlost
Portd = &B_11100100
Waitms Rychlost
Portd = &B_11100010
Waitms Rychlost
Portd = &B_11100001
Waitms Rychlost
Portc = &B_00100000
Portd = &B_11100000
Waitms Rychlost
Portc = &B_00010000
Waitms Rychlost
Portc = &B_00001000
Waitms Rychlost
Portc = &B_00000100
Waitms Rychlost
Portc = &B_00000010
Waitms Rychlost
Portc = &B_00000001
Waitms Rychlost

Loop Until Funkcesave <> 2
   Goto Vyber_funkce

Return

'===============================================================================

Rotacel:

Do
Portc = &B_00000001
Portd = &B_11100000
Waitms Rychlost
Portc = &B_00000010
Waitms Rychlost
Portc = &B_00000100
Waitms Rychlost
Portc = &B_00001000
Waitms Rychlost
Portc = &B_00010000
Waitms Rychlost
Portc = &B_00100000
Waitms Rychlost
Portc = &B_00000000
Portd = &B_11100001
Waitms Rychlost
Portd = &B_11100010
Waitms Rychlost
Portd = &B_11100100
Waitms Rychlost
Portd = &B_11101000
Waitms Rychlost

Loop Until Funkcesave <> 3
   Goto Vyber_funkce

Return

'===============================================================================

Stroboskop:

Do
Portc = &B0011_1111
Portd = &B1110_1111
Waitms Rychlost
Portc = &B0000_0000
Portd = &B1110_0000
Waitms Rychlost
Loop Until Funkcesave <> 4
   Goto Vyber_funkce

Return

'===============================================================================

Bezici_tma:

Do
Portc = &B_00111110
Portd = &B_11101111
Waitms Rychlost
Portc = &B_00111101
Waitms Rychlost
Portc = &B_00111011
Waitms Rychlost
Portc = &B_00110111
Waitms Rychlost
Portc = &B_00101111
Waitms Rychlost
Portc = &B_00011111
Waitms Rychlost
Portc = &B_00111111
Portd = &B_11101110
Waitms Rychlost
Portd = &B_11101101
Waitms Rychlost
Portd = &B_11101011
Waitms Rychlost
Portd = &B_11100111
Waitms Rychlost

   If Funkcesave <> 5 Then
   Goto Vyber_funkce
   End If

Portc = &B_00111111
Portd = &B_11101011
Waitms Rychlost
Portd = &B_11101101
Waitms Rychlost
Portd = &B_11101110
Waitms Rychlost
Portc = &B_00011111
Portd = &B_11101111
Waitms Rychlost
Portc = &B_00101111
Waitms Rychlost
Portc = &B_00110111
Waitms Rychlost
Portc = &B_00111011
Waitms Rychlost
Portc = &B_00111101
Waitms Rychlost

Loop Until Funkcesave <> 5
   Goto Vyber_funkce

Return

'===============================================================================

Knight_rider:

Do
Portc = &B_00000001
Portd = &B_11100000
Waitms Rychlost
Portc = &B_00000010
Waitms Rychlost
Portc = &B_00000100
Waitms Rychlost
Portc = &B_00001000
Waitms Rychlost
Portc = &B_00010000
Waitms Rychlost
Portc = &B_00100000
Waitms Rychlost
Portc = &B_00000000
Portd = &B_11100001
Waitms Rychlost
Portd = &B_11100010
Waitms Rychlost
Portd = &B_11100100
Waitms Rychlost
Portd = &B_11101000
Waitms Rychlost

   If Funkcesave <> 6 Then
   Goto Vyber_funkce
   End If

Portc = &B_00000000
Portd = &B_11100100
Waitms Rychlost
Portd = &B_11100010
Waitms Rychlost
Portd = &B_11100001
Waitms Rychlost
Portc = &B_00100000
Portd = &B_11100000
Waitms Rychlost
Portc = &B_00010000
Waitms Rychlost
Portc = &B_00001000
Waitms Rychlost
Portc = &B_00000100
Waitms Rychlost
Portc = &B_00000010
Waitms Rychlost

Loop Until Funkcesave <> 6
   Goto Vyber_funkce

Return

'===============================================================================

Knight_rider_new:

Do
Portc = &B_00110000
Portd = &B_11100000
Waitms Rychlost
Portc = &B_00111000
Portd = &B_11100001
Waitms Rychlost
Portc = &B_00111100
Portd = &B_11100011
Waitms Rychlost
Portc = &B_00111110
Portd = &B_11100111
Waitms Rychlost
Portc = &B_00111111
Portd = &B_11101111
Waitms Rychlost
Waitms Rychlost

   If Funkcesave <> 7 Then
   Goto Vyber_funkce
   End If

Portc = &B_00001111
Portd = &B_11101111
Waitms Rychlost
Portc = &B_00000111
Portd = &B_11101110
Waitms Rychlost
Portc = &B_00000011
Portd = &B_11101100
Waitms Rychlost
Portc = &B_00000001
Portd = &B_11101000
Waitms Rychlost
Waitms Rychlost

   If Funkcesave <> 7 Then
   Goto Vyber_funkce
   End If

Portc = &B_00000011
Portd = &B_11101100
Waitms Rychlost
Portc = &B_00000111
Portd = &B_11101110
Waitms Rychlost
Portc = &B_00001111
Portd = &B_11101111
Waitms Rychlost
Portc = &B_00111111
Portd = &B_11101111
Waitms Rychlost
Waitms Rychlost

   If Funkcesave <> 7 Then
   Goto Vyber_funkce
   End If

Portc = &B_00111110
Portd = &B_11100111
Waitms Rychlost
Portc = &B_00111100
Portd = &B_11100011
Waitms Rychlost
Portc = &B_00111000
Portd = &B_11100001
Waitms Rychlost
Portc = &B_00110000
Portd = &B_11100000
Waitms Rychlost


   If Funkcesave <> 7 Then
   Goto Vyber_funkce
   End If

Loop

Return

'********************************** KONEC *************************************
' ! nastaveni FUSES v PonyProg !    (viz. http://www.engbedded.com/fusecalc)
' -  : (1) prazne     /     +  : (0) zatrzene (J)
'
' SELFPRGEN          -
' DWEN               -
' BODLEVEL1          -
' BODLEVEL0          -
' EESAVE             -
' WDTOM              -
' CKDIV8             -
' SUT1               - (1)
' SUT0             J + (0)
' CLKSEL3          J + (0)
' CLKSEL2            - (1)
' CLKSEL1          J + (0)
' CLKSEL0          J + (0)
'
'           CLKSEL : 8MHz interni oscilator
'           SUT    : 6CK + 64 ms Slowly rising power
'
'********************************** KONEC *************************************
' Copyright (C) PaJa 2010
' www.paja-trb.cz